# -*- coding: utf-8 -*-

#1a) Una proteina è sintetizzata a partire da una sequenza di mRNA (maturo).
# A causa della degenerazione del codice genetico, una stessa sequenza proteica
# può essere tradotta da molteplici sequenze di mRNA. Tali sequenze possono 
# essere ordinate lessicograficamente. 
# In questo e nei seguenti esercizi, non si consideri il codone di stop.
# Si scriva una funzione firstMRNA(pseq) che, data una sequenza proteica pseq,
# restituisca la stringa corrispondente alla prima sequenza di mRNA (in ordine 
# lessicografico) che può dar luogo a pseq.
#
# Es. 
# firstMRNA("GFSL")     # -> GGAUUCAGCCUA
# firstMRNA("QYAY")     # -> CAAUACGCAUAC
#
# Il codice genetico standard è diponibile nelle strutture dati presenti 
# nel modulo "gencodes" fornito insieme al testo.
 

from gencodes import code_gen

ordered_code_gen = {}
for key in code_gen:
    ordered_code_gen[key] = sorted(code_gen[key])


def firstMRNA(pseq):
    """
    Returns the first mRNA sequence (in lexicographic order)
    that yields the protein sequence provided as input.
    """
    return "".join(ordered_code_gen[aa][0] for aa in pseq)

