# -*- coding: utf-8 -*-

#2a) Data una collezione di stringhe che rappresentano sequenze di RNA, e un 
# tipo di nucleotide (p.es. G), ciascuna stringa ne ha un dato contenuto 
# percentuale. Si scriva una funzione maxContent(rnalist, ntype) che, data una 
# lista di stringhe di RNA e un tipo di nucleotide (p.es. "G") fornisca in 
# output la sottolista delle stringhe che hanno contenuto percentuale massimo 
# di ntype.
#
# Es:
# 
# l=["GGGAA","GGAACCAAUU","UUUUGGGGGG"]
# 
# maxContent(l,"G") # -> ['GGGAA', 'UUUUGGGGGG']


def maxContent(rnalist, ntype):
    """
    Returns the sublist of rnalist containing the strings
    with maximal content ratio of ntype (e.g. "G").
    """
    res = []
    maxContent = 0.
    for seq in rnalist:
        content = seq.count(ntype)/float(len(seq))
        #in the following lines, we do not consider errors
        #possibly due to approximation in representation of floats
        if content < maxContent:
            continue
        if content > maxContent:
            maxContent = content
            res = [seq]
        else:
            res.append(seq)
    return res

